[SHELL] 명령 이 존재 하 는 지 판단 하기

3157 단어 shell
먼저 설명 하고 자 하 는 것 은 which 를 사용 하여 판단 하지 말 라 는 것 이다. 이 유 는 다음 과 같다.
1. which 비 SHELL 의 내장 명령 은 내장 명령 보다 비용 이 많이 들 고 비 내장 명령 은 플랫폼 의 실현 에 의존 하 며 서로 다른 플랫폼 의 실현 이 다 를 수 있 습 니 다.
# type type

type is a shell builtin

# type command

command is a shell builtin

# type which

which is hashed (/usr/bin/which)

2. 많은 시스템 의 which 는 종료 할 때의 반환 값 을 설정 하지 않 습 니 다. 찾 으 려 는 명령 이 존재 하지 않 더 라 도 which 는 0 으로 돌아 갑 니 다.
# which ls

/usr/bin/ls

# echo $?

0

# which aaa

no aaa in /usr/bin /bin /usr/sbin /sbin /usr/local/bin /usr/local/bin /usr/local/sbin /usr/ccs/bin /usr/openwin/bin /usr/dt/bin 

# echo $?

0

3. 많은 시스템 의 which 실현, 모두 몰래 '외부 인도 부족' 한 일 을 했다.
그 러 니 which 를 사용 하지 말고 아래 방법 을 사용 하 세 요.
$ command -v foo >/dev/null 2>&1 || { echo >&2 "I require foo but it's not installed.  Aborting."; exit 1; }

$ type foo >/dev/null 2>&1 || { echo >&2 "I require foo but it's not installed.  Aborting."; exit 1; }

$ hash foo 2>/dev/null || { echo >&2 "I require foo but it's not installed.  Aborting."; exit 1; }

 
날 카 로 운 원문 은 여기 서 볼 수 있다.
http://stackoverflow.com/questions/592620/how-to-check-if-a-program-exists-from-a-bash-script/677212#677212

좋은 웹페이지 즐겨찾기